package mapping;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;

import dtl_algo.DTLReconciliation;
import node.Node;

public class DomainMapping extends RootedBinaryTreeMapping {
	int intraSameTreeOutCost = Integer.MAX_VALUE / 10;
	int intraDifferentTreeOutCost = Integer.MAX_VALUE / 10;
	int interSameTreeOutCost = Integer.MAX_VALUE / 10;
	int interDifferentTreeOutCost = Integer.MAX_VALUE / 10;
	ArrayList<Node>intraSameTreeOutNodes = new ArrayList<Node>();
	ArrayList<Node>intraDifferentTreeOutNodes = new ArrayList<Node>();
	ArrayList<Node>interSameTreeOutNodes = new ArrayList<Node>();
	ArrayList<Node>interDifferentTreeOutNodes = new ArrayList<Node>();
	
	public DomainMapping(Node domainNode, Node geneNode) {
		super(domainNode, geneNode);
		// TODO Auto-generated constructor stub
	}
	public int getIntraSameTreeOutCost() {
		return intraSameTreeOutCost;
	}
	public void setIntraSameTreeOutCost(int intraSameTreeOutCost) {
		this.intraSameTreeOutCost = intraSameTreeOutCost;
	}
	public int getIntraDifferentTreeOutCost() {
		return intraDifferentTreeOutCost;
	}
	public void setIntraDifferentTreeOutCost(int intraDifferentTreeOutCost) {
		this.intraDifferentTreeOutCost = intraDifferentTreeOutCost;
	}
	public int getInterSameTreeOutCost() {
		return interSameTreeOutCost;
	}
	public void setInterSameTreeOutCost(int interSameTreeOutCost) {
		this.interSameTreeOutCost = interSameTreeOutCost;
	}
	public int getInterDifferentTreeOutCost() {
		return interDifferentTreeOutCost;
	}
	public void setInterDifferentTreeOutCost(int interDifferentTreeOutCost) {
		this.interDifferentTreeOutCost = interDifferentTreeOutCost;
	}
	
	public ArrayList<Node> getIntraSameTreeOutNodes() {
		return intraSameTreeOutNodes;
	}
	public void setIntraSameTreeOutNodes(ArrayList<Node> intraSameTreeOutNodes) {
		this.intraSameTreeOutNodes = intraSameTreeOutNodes;
	}
	public ArrayList<Node> getIntraDifferentTreeOutNodes() {
		return intraDifferentTreeOutNodes;
	}
	public void setIntraDifferentTreeOutNodes(ArrayList<Node> intraDifferentTreeOutNodes) {
		this.intraDifferentTreeOutNodes = intraDifferentTreeOutNodes;
	}
	public ArrayList<Node> getInterSameTreeOutNodes() {
		return interSameTreeOutNodes;
	}
	public void setInterSameTreeOutNodes(ArrayList<Node> interSameTreeOutNodes) {
		this.interSameTreeOutNodes = interSameTreeOutNodes;
	}
	public ArrayList<Node> getInterDifferentTreeOutNodes() {
		return interDifferentTreeOutNodes;
	}
	public void setInterDifferentTreeOutNodes(ArrayList<Node> interDifferentTreeOutNodes) {
		this.interDifferentTreeOutNodes = interDifferentTreeOutNodes;
	}
	public int getMinimumTransferCost() {
		
		int minimumInterTransferCost = Math.min(interSameTreeOutCost, interDifferentTreeOutCost);
		int minimumIntraTransferCost = Math.min(intraSameTreeOutCost, intraDifferentTreeOutCost);
		return Math.min(minimumInterTransferCost, minimumIntraTransferCost);
	}
	public void clearAllOutNodes() {
		intraSameTreeOutNodes.clear();
		intraDifferentTreeOutNodes.clear();
		interSameTreeOutNodes.clear();
		interDifferentTreeOutNodes.clear();
	}
//	public DomainMapping getIntraDifferentOutMappingGreedily(DTLReconciliation reconciliation) {
//
//
//
//		if(intraDifferentTreeOutNodes.size()==0)return null;
//		
//
//		DomainMapping greedyMapping = null;
//		BigInteger numberOfSolutions  = new BigInteger("0");
//		
//		for(Node outNode : intraDifferentTreeOutNodes )
//		{
//			DomainMapping mapping = reconciliation.getDomainMappingFromNodes(firstNode, outNode);
//			int comparison = mapping.getNumberOfSolutions().compareTo(numberOfSolutions);
//			if(comparison==1) {
//				numberOfSolutions = mapping.getNumberOfSolutions();
//				greedyMapping = mapping;
//			}
//			else if (comparison==0) {
//				int choice =reconciliation.binaryChoice(); 
//				if(choice == 1) {
//					numberOfSolutions = mapping.getNumberOfSolutions();
//					greedyMapping = mapping;
//				}
//			}
//	//		outNode.incrementMappingCount();
//		}
//			return greedyMapping;
//		
//	
//	
//	}
	
	
//	public DomainMapping getIntraSameOutMappingGreedily(DTLReconciliation reconciliation) {
//
//
//		if(intraSameTreeOutNodes.size()==0)return null;
//		
//
//		DomainMapping greedyMapping = null;
//		BigInteger numberOfSolutions  = new BigInteger("0");
//		
//		for(Node outNode : intraSameTreeOutNodes )
//		{
//			DomainMapping mapping = reconciliation.getDomainMappingFromNodes(firstNode, outNode);
//			int comparison = mapping.getNumberOfSolutions().compareTo(numberOfSolutions);
//			if(comparison==1) {
//				numberOfSolutions = mapping.getNumberOfSolutions();
//				greedyMapping = mapping;
//			}
//			else if (comparison==0) {
//				int choice =reconciliation.binaryChoice(); 
//				if(choice == 1) {
//					numberOfSolutions = mapping.getNumberOfSolutions();
//					greedyMapping = mapping;
//				}
//			}
//	//		outNode.incrementMappingCount();
//		}
//			return greedyMapping;
//		
//	
//	}
	public DomainMapping getIntraDifferentOutMappingRandomly(DTLReconciliation reconciliation) {


		if(intraDifferentTreeOutNodes.size()==0)return null;
		
		Collections.shuffle(intraDifferentTreeOutNodes);
		Node outNode = intraDifferentTreeOutNodes.get(0);
	
		DomainMapping mapping = reconciliation.getDomainMappingFromNodes(firstNode, outNode);
			
			return mapping;
		
	
	}
	public DomainMapping getIntraSameOutMappingRandomly(DTLReconciliation reconciliation) {


		if(intraSameTreeOutNodes.size()==0)return null;
		
		Collections.shuffle(intraSameTreeOutNodes);
		Node outNode = intraSameTreeOutNodes.get(0);
	
		DomainMapping mapping = reconciliation.getDomainMappingFromNodes(firstNode, outNode);
			
			return mapping;
		
	
	}
	public DomainMapping getInterSameOutMappingRandomly(DTLReconciliation reconciliation) {


		if(interSameTreeOutNodes.size()==0)
			return null;
		
		Collections.shuffle(interSameTreeOutNodes);
		Node outNode = interSameTreeOutNodes.get(0);
	
		DomainMapping mapping = reconciliation.getDomainMappingFromNodes(firstNode, outNode);
			
			return mapping;
		
	
	}
	public DomainMapping getInterDifferentOutMappingRandomly(DTLReconciliation reconciliation) {


		if(interDifferentTreeOutNodes.size()==0)return null;
		

		Collections.shuffle(interDifferentTreeOutNodes);
		Node outNode = interDifferentTreeOutNodes.get(0);
	
		DomainMapping mapping = reconciliation.getDomainMappingFromNodes(firstNode, outNode);
			
			return mapping;
		
	
	}
	

	public void addWeightByIntraSameInOut(DomainMapping firstMapping, DomainMapping secondMapping,
			DTLReconciliation reconciliation) { 
			BigInteger inCounts = new BigInteger("0");
			BigInteger outCounts = new BigInteger("0");
			for(Node inNode: firstMapping.getInSpeciesNodes()) {
				Node geneNode = firstMapping.firstNode;
				RootedBinaryTreeMapping inMapping = reconciliation.getMappingFromNodesByIndex(geneNode, inNode, this);
				inCounts = inCounts.add(inMapping.numberOfSolutions);
			}
			for(Node outNode: secondMapping.getIntraSameTreeOutNodes()) {
				Node geneNode = secondMapping.firstNode;
				RootedBinaryTreeMapping outMapping = reconciliation.getMappingFromNodesByIndex(geneNode, outNode, this);
				outCounts = outCounts.add(outMapping.numberOfSolutions);
			}
			
			optionWeights.add(inCounts.multiply(outCounts));
		
	}
	
	public void addWeightByIntraDifferentInOut(DomainMapping firstMapping, DomainMapping secondMapping,
			DTLReconciliation reconciliation) { 
			BigInteger inCounts = new BigInteger("0");
			BigInteger outCounts = new BigInteger("0");
			for(Node inNode: firstMapping.getInSpeciesNodes()) {
				Node geneNode = firstMapping.firstNode;
				RootedBinaryTreeMapping inMapping = reconciliation.getMappingFromNodesByIndex(geneNode, inNode, this);
				inCounts = inCounts.add(inMapping.numberOfSolutions);
			}
			for(Node outNode: secondMapping.getIntraDifferentTreeOutNodes()) {
				Node geneNode = secondMapping.firstNode;
				RootedBinaryTreeMapping outMapping = reconciliation.getMappingFromNodesByIndex(geneNode, outNode, this);
				outCounts = outCounts.add(outMapping.numberOfSolutions);
			}
			
			optionWeights.add(inCounts.multiply(outCounts));
		
	}
	
	public void addWeightByInterSameInOut(DomainMapping firstMapping, DomainMapping secondMapping,
			DTLReconciliation reconciliation) { 
			BigInteger inCounts = new BigInteger("0");
			BigInteger outCounts = new BigInteger("0");
			for(Node inNode: firstMapping.getInSpeciesNodes()) {
				Node geneNode = firstMapping.firstNode;
				RootedBinaryTreeMapping inMapping = reconciliation.getMappingFromNodesByIndex(geneNode, inNode, this);
				inCounts = inCounts.add(inMapping.numberOfSolutions);
			}
			for(Node outNode: secondMapping.getInterSameTreeOutNodes()) {
				Node geneNode = secondMapping.firstNode;
				RootedBinaryTreeMapping outMapping = reconciliation.getMappingFromNodesByIndex(geneNode, outNode, this);
				outCounts = outCounts.add(outMapping.numberOfSolutions);
			}
			
			optionWeights.add(inCounts.multiply(outCounts));
		
	}
	
	
	public void addWeightByInterDifferentInOut(DomainMapping firstMapping, DomainMapping secondMapping,
			DTLReconciliation reconciliation) { 
			BigInteger inCounts = new BigInteger("0");
			BigInteger outCounts = new BigInteger("0");
			for(Node inNode: firstMapping.getInSpeciesNodes()) {
				Node geneNode = firstMapping.firstNode;
				RootedBinaryTreeMapping inMapping = reconciliation.getMappingFromNodesByIndex(geneNode, inNode, this);
				inCounts = inCounts.add(inMapping.numberOfSolutions);
			}
			for(Node outNode: secondMapping.getInterDifferentTreeOutNodes()) {
				Node geneNode = secondMapping.firstNode;
				RootedBinaryTreeMapping outMapping = reconciliation.getMappingFromNodesByIndex(geneNode, outNode, this);
				outCounts = outCounts.add(outMapping.numberOfSolutions);
			}
			
			optionWeights.add(inCounts.multiply(outCounts));
		
	}
	public void updateOutNodes(DTLReconciliation reconciliation, ArrayList<Node> outNodes) {
		this.outNodes.clear();
	
		for(Node outNode: outNodes) {
			//if(reconciliation.checkIntraSpeciesCompatibility(secondNode, outNode)) {
			this.outNodes.add(outNode);
		//	}
		}
	}
	public void updateIntraSpeciesDifferentOutNodes(DTLReconciliation reconciliation, ArrayList<Node> outNodes) {
		intraDifferentTreeOutNodes.clear();
	
		for(Node outNode: outNodes) {
			if(reconciliation.checkIntraSpeciesCompatibility(secondNode, outNode)) {
				intraDifferentTreeOutNodes.add(outNode);
			}
		}
	}
	public void updateInterSpeciesDifferentOutNodes(DTLReconciliation reconciliation, ArrayList<Node> outNodes) {
		interDifferentTreeOutNodes.clear();
	
		for(Node outNode: outNodes) {
			if(!reconciliation.checkIntraSpeciesCompatibility(secondNode, outNode)) {
				interDifferentTreeOutNodes.add(outNode);
			}
		}
	}
	public void updateMappingOption(String direction, String newTransferType) {
		this.options.clear();
		if(direction.equals("leftToLeft")){
		
			if(newTransferType.equals("intraSame"))
			{
				if(this.secondNode.isLeaf()) {
					options.add(211);
				}
				else {
					options.add(1511);
				}
			}
			else if(newTransferType.equals("intraDifferent")) {
				if(this.secondNode.isLeaf()) {
					options.add(212);
				}
				else {
					options.add(1512);
				}
			}
			else if(newTransferType.equals("interSame")) {
				if(this.secondNode.isLeaf()) {
					options.add(221);
				}
				else {
					options.add(1521);
				}
			}
		}
		else {

			this.options.clear();
			if(newTransferType.equals("intraSame"))
			{
				if(this.secondNode.isLeaf()) {
					options.add(311);
				}
				else {
					options.add(1611);
				}
			}
			else if(newTransferType.equals("intraDifferent")) {
				if(this.secondNode.isLeaf()) {
					options.add(312);
				}
				else {
					options.add(1612);
				}
			}
			else if(newTransferType.equals("interSame")) {
				if(this.secondNode.isLeaf()) {
					options.add(321);
				}
				else {
					options.add(1621);
				}
			}
		
		}
	}
}
